<?php

class TVDBM {

	var $plugin;

	public function __construct($plugin) {
		$this->plugin = & $plugin;
	}

	public function getOptions($user_id) {
		return DBManager::get()->query(sprintf("SELECT * FROM tv_options WHERE user_id='%s'",$user_id))->fetch(PDO::FETCH_ASSOC);
	}

	public function setOptions($o) {
		DBManager::get()->query(sprintf("REPLACE INTO tv_options SET user_id='%s', notify=%d", $o['user_id'], $o['notify']));
	}

	public function has_valid_entries($user_id) {
                $entries = array();
		$db = DBManager::get();
                $rr = $db->query(sprintf("SELECT c.*, count(t.category_id) termine FROM tv_category c, tv_termine t WHERE c.visible=1 AND c.user_id='%s' AND t.category_id=c.category_id GROUP BY c.category_id",$user_id))->fetchAll();
		foreach ($rr as $r) {
                        if ($r["seminar_id"])
                                if (!$GLOBALS['perm']->have_studip_perm("user",$r["seminar_id"]))
                                        continue;
                        array_push($entries, $r["category_id"]);
                }
                return (count($entries) == 0 ? FALSE : TRUE);
        }

	public function add_termin_to_calendar($termin_id, $user_id) {
		$db = DBManager::get();
                $rr = $db->query(sprintf("SELECT t.*, c.titel c_titel FROM tv_termine t, tv_category c WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id))->fetchAll();
                if (count($rr)) {
                        $new_id = md5(uniqid(time()));
                        $db->query(sprintf("INSERT INTO calendar_events (event_id, range_id, autor_id, uid, start, end, summary,
                                        class, category_intern, priority, location, ts, rtype, mkdate, chdate)
                                        VALUES ('%s','%s','%s','%s',%d,%d,'%s','%s',%d,%d,'%s',UNIX_TIMESTAMP(),'%s',UNIX_TIMESTAMP(),UNIX_TIMESTAMP())",
                                        $new_id,
                                        $user_id,
                                        $user_id,
                                        'Stud.IP-'.$user_id.'@'.$termin_id,
                                        $rr[0]['von'],
                                        $rr[0]['bis'],
                                        $rr[0]['c_titel'],
                                        'PRIVATE',
                                        1,
                                        0,
                                        $rr[0]['ort'],
                                        'SINGLE'
                                        ));
                }
        }

	public function is_unique_entry($cat_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT unique_entry FROM tv_category WHERE category_id='%s'",$cat_id))->fetchAll();
                if (count($r)) {
                        return ($r[0]["unique_entry"] == 1 ? TRUE : FALSE);
                }
                return FALSE;
        }

	public function is_already_booked($cat_id, $user_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT t.termin_id FROM tv_termine t, tv_termine_user tu WHERE t.category_id='%s' AND tu.termin_id=t.termin_id AND tu.user_id='%s'",$cat_id, $user_id))->fetchAll();
                return (count($r) == 0 ? FALSE : TRUE);
        }

	public function send_messages($rcv, $subj, $cnt, $force=FALSE) {
                if (!check_ticket($_REQUEST['ticket'])) return null;
                $m = new messaging;
                if (is_array($rcv) && count($rcv) > 0)
                        foreach ($rcv as $r)
                                $m->insert_message($cnt, get_username($r), $GLOBALS['auth']->auth['uid'], FALSE, FALSE, '', FALSE, $subj, $force);
                return count($rcv);
        }

	public function sendNotification($c, $t) {
		$m = new messaging;
		$cnt = sprintf(dgettext('tv','%s (%s) hat sich zu einem Termin in der Kategorie %s am %s um %s Uhr angemeldet.'), get_fullname($GLOBALS['auth']->auth['uid'], 'no_title'), get_username($GLOBALS['auth']->auth['uid']), $c['titel'], date('d.m.Y',$t['von']), date('H:i',$t['von']));
		$m->insert_message($cnt, get_username($c['user_id']), '____%system%____', FALSE, FALSE, '', FALSE, dgettext('tv','Neue Terminbuchung'), FALSE);
	}

	public function sendUnjoinNotification($c, $t) {
		$m = new messaging;
		$cnt = sprintf(dgettext('tv','%s (%s) hat sich von einem Termin in der Kategorie %s am %s um %s Uhr abgemeldet.'), get_fullname($GLOBALS['auth']->auth['uid'], 'no_title'), get_username($GLOBALS['auth']->auth['uid']), $c['titel'], date('d.m.Y',$t['von']), date('H:i',$t['von']));
		$m->insert_message($cnt, get_username($c['user_id']), '____%system%____', FALSE, FALSE, '', FALSE, dgettext('tv','Terminabmeldung'), FALSE);
	}

	public function get_overlapped_dates($von, $bis) {
                $date_range = "(von<=$von AND bis>=$bis) OR (bis>$von AND bis<=$bis) OR (von<$bis AND von>=$von) OR (von>=$von AND bis<=$bis)";
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT t.*, c.titel cat_titel FROM tv_termine t, tv_category c WHERE c.category_id=t.category_id AND t.user_id='%s' AND (%s) ORDER BY c.titel, t.von", $GLOBALS['auth']->auth['uid'], $date_range))->fetchAll();
                return $r;
        }

	public function get_registered_persons_cat($cat_id) {
                $ret = array();
		$db = DBManager::get();
                $rr = $db->query(sprintf("SELECT DISTINCT a.* FROM auth_user_md5 a, tv_termine_user t, tv_termine te WHERE te.category_id='%s' AND t.termin_id=te.termin_id AND a.user_id=t.user_id ORDER BY a.Nachname, a.Vorname, a.username",$cat_id))->fetchAll();
		foreach ($rr as $r) {
                        array_push($ret, array("user_id"=>$r["user_id"],"username"=>$r["username"],"vorname"=>$r["Vorname"],"nachname"=>$r["Nachname"]));
                }
                return $ret;
        }

	public function get_registered_persons($termin_id) {
                $ret = array();
		$db = DBManager::get();
                $rr = $db->query(sprintf("SELECT a.*, t.zusatz FROM auth_user_md5 a, tv_termine_user t WHERE t.termin_id='%s' AND a.user_id=t.user_id",$termin_id))->fetchAll();
		foreach ($rr as $r) {
                        array_push($ret, array("user_id"=>$r["user_id"],"username"=>$r["username"],"vorname"=>$r["Vorname"],"nachname"=>$r["Nachname"],"zusatz"=>$r["zusatz"]));
                }
                return $ret;
        }

	public function get_max_number_of_registrations($termin_id) {
		$db = DBManager::get();
		$r = $db->query(sprintf("SELECT anz_pers FROM tv_termine WHERE termin_id='%s'",$termin_id))->fetchAll();
		return $r[0]['anz_pers'];
	}

	public function get_owner_of_category($category_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT user_id FROM tv_category WHERE category_id='%s'",$category_id))->fetchAll();
                if (count($r))
                        return $r[0]['user_id'];
                else
                        return FALSE;
        }

	public function add_myself_to_termin($termin_id, $zusatz, $user_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT * FROM tv_termine_user WHERE termin_id='%s' AND user_id='%s'",$termin_id, $user_id))->fetchAll();
                if (!count($r)) {
                        $db->query(sprintf("INSERT INTO tv_termine_user (termin_id, user_id, zusatz) VALUES ('%s', '%s', '%s')", $termin_id, $user_id, mysql_escape_string($zusatz)));
                        $this->add_termin_to_calendar($termin_id, $user_id);
                }
        }

	public function remove_person_from_termin($termin_id, $pers_id) {
		$db = DBManager::get();
                $db->query(sprintf("DELETE FROM tv_termine_user WHERE termin_id='%s' AND user_id='%s'",$termin_id, $pers_id));
                $db->query(sprintf("DELETE FROM calendar_events WHERE autor_id='%s' AND range_id='%s' AND uid='%s'",
                        $pers_id,
                        $pers_id,
                        'Stud.IP-'.$pers_id.'@'.$termin_id));
        }

	public function has_joined($termin_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT * FROM tv_termine_user WHERE termin_id='%s' AND user_id='%s'",$termin_id, $GLOBALS['auth']->auth['uid']))->fetchAll();
                if (count($r))
                        return $r[0];
                else
                        return FALSE;
        }

	public function max_persons_reached($termin_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT t.termin_id, t.anz_pers, COUNT(u.user_id) user_count FROM tv_termine t, tv_termine_user u WHERE t.termin_id='%s' AND u.termin_id=t.termin_id GROUP BY t.termin_id",$termin_id))->fetchAll();
                if (count($r)) {
                        if ($r[0]["anz_pers"] > $r[0]["user_count"])
                                return FALSE;
                        else
                                return TRUE;
                }
                return FALSE;
        }

	public function get_number_of_bookings($category_id, $zeit='new') {
                $r = DBManager::get()->query(sprintf("SELECT COUNT(tu.user_id) anz FROM tv_termine t, tv_termine_user tu WHERE t.category_id='%s' AND tu.termin_id=t.termin_id %s",$category_id, ($zeit == 'new' ? "AND t.von >= UNIX_TIMESTAMP()" : 'AND t.bis < UNIX_TIMESTAMP()')))->fetch(PDO::FETCH_ASSOC);
                return $r['anz'];
        }

	public function generate_termine($category_id) {
                if ($_REQUEST['bis_m'] == "" && $_REQUEST['bis_t'] == "" && $_REQUEST['bis_j'] == "") {
                        $_REQUEST['bis_m'] = $_REQUEST['von_m'];
                        $_REQUEST['bis_t'] = $_REQUEST['von_t'];
                        $_REQUEST['bis_j'] = $_REQUEST['von_j'];
                }

                $tag_von  = mktime(0, 0, 0, $_REQUEST['von_m'], $_REQUEST['von_t'], $_REQUEST['von_j']);
                $tag_bis  = mktime(0, 0, 0, $_REQUEST['bis_m'], $_REQUEST['bis_t'], $_REQUEST['bis_j']);
                $zeit_von = mktime($_REQUEST['von_h'], $_REQUEST['von_i']);
                $zeit_bis = mktime($_REQUEST['bis_h'], $_REQUEST['bis_i']);
                $turnus   = $_REQUEST['turnus'];
                $rahmen   = $_REQUEST['rahmen'];
                $zeitraum = $_REQUEST['zeitraum'];

                $rahmen_sek = $rahmen * 60;
                $zeitraum_sek = $zeitraum * 60;

                $von_t = $_REQUEST['von_t'];
                $von_m = $_REQUEST['von_m'];
                $von_j = $_REQUEST['von_j'];
                $von_h = $_REQUEST['von_h'];
                $von_i = $_REQUEST['von_i'];

                $bis_t = $_REQUEST['bis_t'];
                $bis_m = $_REQUEST['bis_m'];
                $bis_j = $_REQUEST['bis_j'];
                $bis_h = $_REQUEST['bis_h'];
                $bis_i = $_REQUEST['bis_i'];

                $tagessekunden_von = $von_h * 60 * 60 + $von_i * 60;
                $tagessekunden_bis = $bis_h * 60 * 60 + $bis_i * 60;

                /*
                //Debug
                echo "<SPAN STYLE=\"font-size:x-small;\">\n";
                echo "von_t=".$_REQUEST['von_t']."<BR>\n";
                echo "von_m=".$_REQUEST['von_m']."<BR>\n";
                echo "von_j=".$_REQUEST['von_j']."<BR>\n";
                echo "von_h=".$_REQUEST['von_h']."<BR>\n";
                echo "von_i=".$_REQUEST['von_i']."<BR>\n";
                echo "bis_t=".$_REQUEST['bis_t']."<BR>\n";
                echo "bis_m=".$_REQUEST['bis_m']."<BR>\n";
                echo "bis_j=".$_REQUEST['bis_j']."<BR>\n";
                echo "bis_h=".$_REQUEST['bis_h']."<BR>\n";
                echo "bis_i=".$_REQUEST['bis_i']."<BR>\n";
                echo "turnus=$turnus<BR>\n";
                echo "rahmen=$rahmen<BR>\n";
                echo "zeitraum=$zeitraum<BR>\n";
                echo "tag_von=".$tag_von." (".date("d.m.Y",$tag_von).")<BR>\n";
                echo "tag_bis=".$tag_bis." (".date("d.m.Y",$tag_bis).")<BR>\n";
                echo "zeit_von=".$zeit_von." (".date("H:i",$zeit_von).")<BR>\n";
                echo "zeit_bis=".$zeit_bis." (".date("H:i",$zeit_bis).")<BR>\n";
                echo "</SPAN><BR>\n";
                */

                $termine = array();

                if ($tag_von > 0 && $tagessekunden_von < $tagessekunden_bis) {
                        $start_zeit = mktime($von_h, $von_i, 0, date('m',$tag_von), date('d',$tag_von), date('Y',$tag_von));
                        // Nur ein Tag..., turnus kann ignoriert werden
                        if ($tag_bis < 0) {
                                $end_zeit = mktime($bis_h, $bis_i, 0, date('m',$tag_von), date('d',$tag_von), date('Y',$tag_von));
                                if ($start_zeit < $end_zeit) {
                                        $zeitpunkt = $start_zeit;
                                        $t = 0;
                                        while ($zeitpunkt <= $end_zeit) {
                                                //echo date("d.m.Y - H:i",$zeitpunkt);
                                                $zeitpunkt_bis = $zeitpunkt + $rahmen_sek;
                                                //echo " bis ".date("d.m.Y - H:i",$zeitpunkt_bis)."<BR>\n";

                                                array_push($termine, array($zeitpunkt, $zeitpunkt_bis));

                                                $zeitpunkt += $rahmen_sek + $zeitraum_sek;
                                                $t++;
                                                if ($t==100) exit;
                                        }
                                }
                        } else {
                                // Termine ueber mehrere Tage
                                $end_zeit = mktime($bis_h, $bis_i, 0, date('m',$tag_bis), date('d',$tag_bis), date('Y',$tag_bis));
                                if ($start_zeit < $end_zeit) {
                                        $zeitpunkt = $start_zeit;
                                        $t = 0;
                                        while ($zeitpunkt <= $end_zeit) {
                                                //echo date("d.m.Y - H:i",$zeitpunkt);
                                                $zeitpunkt_bis = $zeitpunkt + $rahmen_sek;
                                                //echo " bis ".date("d.m.Y - H:i",$zeitpunkt_bis)."<BR>\n";

                                                // Sind wir bei einem Wochenendetag gelandet?
                                                if (!($turnus == 2 && (date('D',$zeitpunkt) == 'Sat' || date('D',$zeitpunkt) == 'Sun')))
                                                        // Ueberschreitet der Termin die maximale Zeitangabe? (oder liegt davor bzw. ist schon der naechste Tag)
                                                        if ($zeitpunkt_bis <= mktime($bis_h,$bis_i,0,date('m',$zeitpunkt_bis), date('d',$zeitpunkt_bis), date('Y',$zeitpunkt_bis)) &&
                                                            // liegt der Zeitpunkt vor der Startzeit?
                                                            $zeitpunkt >= mktime($von_h,$von_i,0,date('m',$zeitpunkt), date('d',$zeitpunkt), date('Y',$zeitpunkt)) &&
                                                            // befinden wir uns noch am gleichen Tag?
                                                            date('d.m.Y',$zeitpunkt) == date('d.m.Y',$zeitpunkt_bis)
                                                           )
                                                                array_push($termine, array($zeitpunkt, $zeitpunkt_bis));

                                                $zeitpunkt += $rahmen_sek + $zeitraum_sek;
                                                $t_zp = mktime($bis_h, $bis_i, 0, date('m',$zeitpunkt),date('d',$zeitpunkt), date('Y',$zeitpunkt));
                                                if ($turnus == 1 || $turnus == 2) { // taeglich
                                                        if ($zeitpunkt > $t_zp) { // wenn der zp nach der max-Urhzeit liegt, fange bei nchstem Tag wieder an.
                                                                $zeitpunkt = mktime($von_h, $von_i, 0, date('m',$zeitpunkt), date('d',$zeitpunkt) + 1, date('Y',$zeitpunkt));
                                                        }
                                                }
                                                if ($turnus == 7 || $turnus == 14) { // woechentlich / zwei-woechentlich
                                                        if ($zeitpunkt > $t_zp) { // wenn der zp nach der max-Urhzeit liegt, fange bei nchster Woche wieder an.
                                                                $zeitpunkt = mktime($von_h, $von_i, 0, date('m',$zeitpunkt), date('d',$zeitpunkt) + $turnus, date('Y',$zeitpunkt));
                                                        }
                                                }
                                                $t++;
                                                if ($t==10000) {
                                                        // Bei zu vielen Terminen oder einer unwahrscheinlichen Endlosschleife, Ergebnisse rausgeben
                                                        return $termine;
                                                }
                                        }
                                }
                        }
                }
                return $termine;
        }

	public function get_overlapped_dates_txt($arr) {
                $txt = "";
                $c_title = "";
                foreach ($arr as $t) {
                        if ($c_title != $t['cat_titel']) {
                                $c_title = $t['cat_titel'];
                                $txt .= $c_title."\n";
                        }
                        $txt .= $this->plugin->php_tage_short[date('w',$t["von"])].". ".date('d.m.Y H:i', $t["von"])." - ".date('H:i', $t["bis"])."\n";
                }
                return $txt;
        }


	function getSeminare() {
		$db = DBManager::get();
		$r = $db->query(sprintf("SELECT s.*, sem.name sem_name FROM seminare s, seminar_user su, semester_data sem WHERE s.Seminar_id=su.Seminar_id AND su.status IN ('tutor','dozent') AND su.user_id='%s' AND s.start_time >= sem.beginn AND s.start_time <= sem.ende ORDER BY s.start_time DESC",$GLOBALS['auth']->auth['uid']))->fetchAll();
		return $r;
	}

	function getCategory($cat_id) {
		$db = DBManager::get();
		$r = $db->query(sprintf("SELECT * FROM tv_category WHERE category_id='%s'",$cat_id))->fetchAll();
		return $r[0];
	}

	function getCategorySeminare($cat_id=FALSE) {
		if (!$cat_id) return array();
		$db = DBManager::get();
		$r = $db->query(sprintf("SELECT s.*, sem.name sem_name FROM tv_category_seminare c, seminare s, semester_data sem WHERE s.Seminar_id=c.seminar_id AND s.start_time >= sem.beginn AND s.start_time <= sem.ende AND c.category_id='%s' ORDER BY s.start_time DESC", $cat_id))->fetchAll();
		return $r;
	}

	function getUsersBookingList($user_id) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT t.termin_id, t.von, t.bis, t.ort, t.enddate_admission t_enddate_admission, c.category_id, c.titel, c.user_id autor_id, c.enddate_admission, tu.zusatz FROM tv_termine_user tu, tv_termine t, tv_category c WHERE tu.user_id='%s' AND t.termin_id=tu.termin_id AND c.category_id=t.category_id ORDER BY t.von, t.bis, c.titel",$user_id))->fetchAll();
		return $r;

	}

	function getCategoriesByUser($user_id, $visible=FALSE) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT * FROM tv_category WHERE user_id='%s' %s ORDER BY titel",$user_id,($visible ? " AND visible=1" : "")))->fetchAll();
		return $r;

	}

	function getCategoryTermine($cat_id, $zeit='new') {
		$db = DBManager::get();
		$r = $db->query(sprintf("SELECT * FROM tv_termine WHERE category_id='%s' %s ORDER BY von",$cat_id, ($zeit == 'new' ? "AND von >= UNIX_TIMESTAMP()" : 'AND bis < UNIX_TIMESTAMP()')))->fetchAll();
		return $r;
	}

	function getCurrentTermine($cat_id) {
		$db = DBManager::get();
		$r = $db->query(sprintf("SELECT * FROM tv_termine WHERE category_id='%s' AND visible=1 AND bis>UNIX_TIMESTAMP() ORDER BY von",$cat_id))->fetchAll();
		return $r;
	}

	function getTermin($termin_id, $user_id=FALSE) {
		$db = DBManager::get();
                $r = $db->query(sprintf("SELECT * FROM tv_termine WHERE termin_id='%s' %s",$termin_id,($user_id ? " AND user_id='$user_id'" : "")))->fetchAll();
		if (count($r))
			return $r[0];
		else return FALSE;
	}

	function updateCategory($unique_entry, $cat_name, $cat_desc, $visible, $seminar_ids, $ende, $zusatz_active, $zusatz, $zusatz_mandatory, $zusatz_verify, $userid, $category_id, $notification) {
		$db = DBManager::get();
		$db->query(sprintf("UPDATE tv_category SET unique_entry=%d, titel='%s', bemerkungen='%s', visible=%d, enddate_admission=%d, zusatz_active=%d, zusatz_text='%s', zusatz_mandatory=%d, zusatz_verify='%s', notification=%d WHERE user_id='%s' AND category_id='%s'",$unique_entry,mysql_escape_string(trim($cat_name)),mysql_escape_string(trim($cat_desc)), $visible, $ende, $zusatz_active, mysql_escape_string($zusatz), $zusatz_mandatory, mysql_escape_string($zusatz_verify), $notification, $userid, $category_id));
		$db->query(sprintf("DELETE FROM tv_category_seminare WHERE category_id='%s'",$category_id));
		if ($seminar_ids) {
			foreach ($seminar_ids as $s)
				$db->query(sprintf("INSERT INTO tv_category_seminare (category_id, seminar_id) VALUES ('%s','%s')",$category_id, $s));
		}
	}

	function createCategory($new_id,$cat_name,$cat_desc, $visible, $unique_entry, $seminar_ids, $ende, $zusatz_active, $zusatz, $zusatz_mandatory, $zusatz_verify, $notification) {
		$db = DBManager::get();
		$db->query(sprintf("INSERT INTO tv_category (category_id, user_id, titel, bemerkungen, visible, unique_entry, enddate_admission, zusatz_active, zusatz_text, zusatz_mandatory, zusatz_verify, notification) VALUES ('%s','%s','%s','%s', %d, %d, %d, %d, '%s', %d, '%s', %d)",$new_id,$GLOBALS['auth']->auth['uid'],mysql_escape_string(trim($cat_name)),mysql_escape_string(trim($cat_desc)), $visible, $unique_entry, $ende, $zusatz_active, mysql_escape_string($zusatz), $zusatz_mandatory, mysql_escape_string($zusatz_verify), $notification));
		if ($seminar_ids) {
			$db->query(sprintf("DELETE FROM tv_category_seminare WHERE category_id='%s'",$category_id));
			foreach ($seminar_ids as $s)
				$db->query(sprintf("INSERT INTO tv_category_seminare (category_id, seminar_id) VALUES ('%s','%s')",$category_id, $s));
		}
	}

	function createTermin($new_id, $category_id, $von_t, $bis_t, $ort, $anz_pers) {
		$db = DBManager::get();
		$db->query(sprintf("INSERT INTO tv_termine (termin_id, category_id, user_id, von, bis, ort, visible, anz_pers) VALUES ('%s','%s','%s',%d,%d,'%s',1,%d)",$new_id, $category_id, $GLOBALS['auth']->auth['uid'], $von_t, $bis_t, mysql_escape_string(trim($ort)), $anz_pers));
		
	}

	function updateTermin($von, $bis, $ort, $anz_pers, $ende, $termin_id) {
		$db = DBManager::get();
		$db->query(sprintf("UPDATE tv_termine SET von=%d, bis=%d, ort='%s', anz_pers=%d, enddate_admission=%d WHERE termin_id='%s'",$von, $bis, mysql_escape_string(trim($ort)), $anz_pers, $ende, $termin_id));
	}

	function removeTermin($termin_id, $send_messages = FALSE) {
		$db = DBManager::get();
		$rr = $db->query(sprintf("SELECT c.*, t.von, t.bis FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id))->fetchAll();
		$m = new messaging;
		foreach ($rr as $r) {
			$message = sprintf("Der Termin (%s am %s, %s Uhr) wurde von dem Eigentuemer (%s) bzw. einem Administrator geloescht.\n\n",$r['titel'],date('d.m.Y',$r['von']),(date('H:i',$r['von']).' - '.date('H:i',$r['bis'])),htmlReady(get_fullname($r['user_id'])));
			if ($r['user_id'] == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
				if ($send_messages == 'yes') {
					$uu = $db->query(sprintf("SELECT user_id FROM tv_termine_user WHERE termin_id='%s'",$termin_id))->fetchAll();
					foreach ($uu as $u)
						$m->insert_message($message, get_username($u['user_id']), "____%system%____", FALSE, FALSE, 1, FALSE, dgettext('tv',"Termin geloescht"));
				}
				$db->query(sprintf("DELETE FROM tv_termine_user WHERE termin_id='%s'",$termin_id));
				$db->query(sprintf("DELETE FROM tv_termine WHERE termin_id='%s'",$termin_id));
			}
		}
	}

	function removeCategory($cat_id) {
		$db = DBManager::get();
		$termine = $db->query(sprintf("SELECT * FROM tv_termine WHERE category_id='%s'",$cat_id))->fetchAll();
		foreach ($termine as $t) {
			$db->query(sprintf("DELETE FROM tv_termine_user WHERE termin_id='%s'",$t["termin_id"]));
		}
		$db->query(sprintf("DELETE FROM tv_termine WHERE category_id='%s'",$cat_id));
		$db->query(sprintf("DELETE FROM tv_category_seminare WHERE category_id='%s'",$cat_id));
		$db->query(sprintf("DELETE FROM tv_category WHERE category_id='%s'",$cat_id));

	}

	function getCategoryFromTermin($termin_id) {
		$db = DBManager::get();
		$t = $db->query(sprintf("SELECT c.* FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id))->fetchAll();
		if (count($t)) return $t[0];
		else return FALSE;
	}

	function getTerminWithCategoryData($termin_id) {
		$db = DBManager::get();
		$t = $db->query(sprintf("SELECT c.*, t.von, t.bis FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id))->fetchAll();
		if (count($t)) return $t[0];
		else return FALSE;
	}

	function isSeminarMember($cat_id) {
		$vas = $this->getCategorySeminare($cat_id);
		if (count($vas)) {
			foreach ($vas as $v)
				if ($GLOBALS['perm']->have_studip_perm("user",$v["Seminar_id"])) return TRUE;
			return FALSE;
		} else return TRUE;
	}
	
	function searchForSeminare($val) {
                $db = DBManager::get();
                $rr = $db->query(sprintf("SELECT s.*, sem.name sem_name FROM seminare s, semester_data sem WHERE LOWER(s.Name) LIKE LOWER('%s') AND s.start_time >= sem.beginn AND s.start_time <= sem.ende ORDER BY s.start_time DESC",'%'.$val.'%'))->fetchAll();
		$ret = array();
                foreach ($rr as $r)  {
			$ret[] = array("seminar_id"=>$r['Seminar_id'], "sem_name"=>$r['sem_name'], "name"=>utf8_encode(mila($r['Name'],45).($r["VeranstaltungsNummer"] ? " (".$r["VeranstaltungsNummer"].")":"")));
                }
                return $ret;
        }

	function searchForPersonas($val) {
                $db = DBManager::get();
                $rr = $db->query(sprintf("SELECT * FROM auth_user_md5 WHERE visible NOT IN ('no','never') AND locked=0 AND (UPPER(Nachname) LIKE UPPER('%s') OR UPPER(username) LIKE UPPER('%s')) ORDER BY Nachname, Vorname, username",'%'.$val.'%','%'.$val.'%'))->fetchAll();
		$ret = array();
                foreach ($rr as $r)  {
			$ret[] = array("user_id"=>$r['user_id'], "nachname"=>utf8_encode($r['Nachname']), "vorname"=>utf8_encode($r['Vorname']),"username"=>$r["username"]);
                }
                return $ret;
        }

}

?>
