#!/usr/bin/php -q
<?php
require_once dirname(__FILE__) . '/../../../../../cli/studip_cli_env.inc.php';
require_once 'lib/language.inc.php';
require_once 'lib/functions.php';
require_once 'lib/messaging.inc.php';
require_once dirname(__FILE__) . '/../classes/TVDBM.class.php';

get_config('TV_REMINDER') || trigger_error('Homepageterminvergabe reminders are disabled in this Stud.IP installation.', E_USER_ERROR);

set_time_limit(60*60*2);

$next_24_hours = time() + 24 * 60 * 60;
$messaging=new messaging;
$db = DBManager::get();
$notifiers = $db->query("SELECT user_id FROM tv_options WHERE notify=1")->fetchAll();
if (!count($notifiers)) die;
foreach ($notifiers as $n) {
	// wo ist der User gebucht?
	$rr = $db->query(sprintf("SELECT t.von, t.bis, t.ort, c.titel FROM tv_termine_user tu, tv_termine t, tv_category c WHERE tu.user_id='%s' AND t.termin_id=tu.termin_id AND c.category_id=t.category_id AND t.von BETWEEN UNIX_TIMESTAMP() AND %d ORDER BY t.von, t.bis, c.titel", $n['user_id'], $next_24_hours))->fetchAll();
	$txt = "";
	if (count($rr)) {
		$txt .= "!Fr folgende Termine sind Sie gebucht:".chr(13).chr(10);
		foreach ($rr as $r) {
			$txt .= "- ".stripslashes($r['titel']).", ".date("d.m.Y H:i",$r["von"])." bis ".date("H:i",$r['bis'])." Uhr (".$r["ort"].")".chr(13).chr(10);
		}
	}
	// welche Buchungen sind fuer eigene Termine vorhanden?
	$rr = $db->query(sprintf("SELECT t.termin_id, t.von, t.bis, t.ort, c.titel FROM tv_termine t, tv_category c WHERE t.user_id='%s' AND EXISTS (SELECT tu.user_id FROM tv_termine_user tu WHERE tu.termin_id=t.termin_id) AND c.category_id=t.category_id AND t.von BETWEEN UNIX_TIMESTAMP() AND %d ORDER BY t.von, t.bis, c.titel", $n['user_id'], $next_24_hours))->fetchAll();
	if (count($rr)) {
		$txt .= "!Folgende Termine von Ihnen sind gebucht:".chr(13).chr(10);
		foreach ($rr as $r) {
			$bookings = $db->query(sprintf("SELECT user_id FROM tv_termine_user WHERE termin_id='%s'",$r['termin_id']))->fetchAll();
			$booking_user = "";
			foreach ($bookings as $b) {
				$booking_user .= get_fullname($b['user_id'], 'no_title').', ';
			}
			if (strlen($booking_user) > 2) {
				$booking_user = substr($booking_user, 0, -2);
			}
			$txt .= "- ".stripslashes($r['titel']).", ".date("d.m.Y H:i",$r["von"])." bis ".date("H:i",$r['bis'])." Uhr (".$r["ort"]."): ".$booking_user.chr(13).chr(10);
		}
	}
	if ($txt) {
		echo get_username($n['user_id']).$txt.chr(13).chr(10).chr(13).chr(10);
		$messaging->insert_message($txt, get_username($n['user_id']), "____%system%____", FALSE, FALSE, 1, FALSE, _("Terminvergabe: bersicht der nchsten 24 Stunden"));
	}
}

?>
